import unittest
#from world import World
#from point import Point
#from waypoint import Waypoint
from cell import Cell

from domain import *

import types, sys

#-------------------------------------------------------------

class TestCase(unittest.TestCase):

    def setUp(self):
        self.cell = Cell(100,140,0,40,'cell')
        
        a = [3, 107]
        b = [5, 107]
        c = [5, 105]
        d = [7, 107]
        e = [15, 115]
        f = [15, 130]
        g = [30, 110]
        h = [30, 130]

        points = [a, b, c, d, e, f, g, h]
        #bac, bce, ecf, dbe, daf, dae 
        vertices = [ [1,0,2],[1,3,4], [1,2,3], [5,4,7], [4,6,7]] 

        conserved_quantities = ['level', 'xmomentum', 'ymomentum']
        other_quantities = ['elevation', 'friction']
        
        domain = Domain(points, vertices, None,
                        conserved_quantities, other_quantities)
        Cell.initialise(domain)
        
    def tearDown(self):
        pass

    def test_add_points_2_cell(self):
        self.cell.Insert(0)
        self.cell.Insert(1)
        
        result = self.cell.Retrieve()
        #result = self.cell.Get_tree()
        #print  result 
        assert type(result) in [types.ListType,types.TupleType], 'should be a list'        
        self.assertEqual(len(result),2)
        
    def test_add_points_2_cellII(self):
        self.cell.Insert([0,1,2,3,4,5,6,7])
        
        result = self.cell.Retrieve()
        #result = self.cell.Get_tree()
        #print  result 
        assert type(result) in [types.ListType,types.TupleType], 'should be a list'        
        self.assertEqual(len(result),8)


    def test_search(self):
        self.cell.Insert([0,1,2,3,4,5,6,7])
        
        result =  self.cell.Search(x = 1, y = 101)
        assert type(result) in [types.ListType,types.TupleType], 'should be a list'        
        self.assertEqual(result, [0,1,2,3])

#-------------------------------------------------------------
if __name__ == "__main__":

    mysuite = unittest.makeSuite(TestCase,'test')
    runner = unittest.TextTestRunner()
    runner.run(mysuite)

